<?php
/**
  * @author Auguria <info@auguria.net>
  * @copyright Auguria
  * @license http://www.opensource.org/licenses/osl-3.0.php Open-source licence 3.0
  * @version 0.1
  */

class DranerSms_API {	
	const text_pattern = '#^(\s|[a-zA-Z0-9\'\?\(\)\<\>\.\+ÄÅÆÇÉÖÑÜàäåæéèìòöñùü/%=,;:"!¡¿@£$¥\#¤&-])*$#';
	
	var $urls = array(
		//'sendSMS' => 'http://www.lyra-sms.com/bulksms/sendSmsAction.do',
		'sendSMS' => 'http://www.123-sms.net/http.php?email=$user&pass=$password&numero=$phone&message=$text',
	//"http://www.123-sms.net/http.php?email=$sms_email&pass=$sms_pass&numero=$sms_destination&message=".urlencode($message));
		//'accountStatement' => 'http://www.lyra-sms.com/bulksms/accountStatementAction.do'
		'accountStatement' => 'http://www.123-sms.net/http.php?email=$user&pass=$password'
	);
	var $timeout = 10;
	
	var $user;
	var $password;
	
	var $phone;
	var $text = '';
	
	var $acquittement = '0';
	var $accuse = '1';
	var $classe1 = '1';
	var $classe = '00';
	
	var $deadline;
	var $smsHttpId;
	
	function DranerSms_API($user=null, $password=null, $text=null) {
		if($user!==null)
			$this->user = $user;
		if($password!==null)
			$this->password = $password;
		if($text !== null)
			$this->text = $text;
	}
	
	static function isValidText($text) {
		return preg_match(DranerSms_API::text_pattern, $text);
	}
	
	static function prepareText($text, $variables = null, $utf8=true){
		$variables = is_array($variables) ? $variables : array();
		foreach ($variables as $token => $value) {
			$text = str_replace($token, $value, $text);
		}
		
		if(!DranerSms_API::isValidText($text))
			return false;
			
		if($utf8)
			$text = utf8_decode($text);	// store in iso-8859-1 for urlencode in sendSMS
					
		return $text;
	}
	
	/**
	 *
	 * @param $phone
	 * @param $text
	 * @param $option
	 * @param $deadline
	 * @param $smsHttpId
	 * @return mixed uan array with the answer (status=>...) or false
	 */
	function sendSMS($phone=null, $text=null, $option=null, $deadline=null, $smsHttpId=null) {
		$response = false;
		$params = array();
		
		// access url
		$url = "http://www.123-sms.net/http.php";
		$params['email'] = $this->user;
		$params['pass']= $this->password;
		$params['numero'] = ($phone === null) ? $this->phone : $phone;
		$params['message'] = ($text === null) ? $this->text : $text;
		
		// access url
		$url = "http://www.123-sms.net/http.php";
		// request
		$request = '';
		foreach($params as $key => $value) 
		{			
			$request .= $key . '=' . urlencode($value); // formater les valeurs
			$request .= '&';
		}		
				
		$reponse = file_get_contents($url . '?' . $request);
		
		if ($reponse == "80")	
		{ // success 
			Configuration::updateValue('DranerSms_NUMBER_SENT',Configuration::get('DranerSms_NUMBER_SENT') + 1);
		} else 
		{ // Failure
			Configuration::updateValue('DranerSms_NUMBER_ERROR', Configuration::get('DranerSms_NUMBER_ERROR') + 1);
			$date = Tools::displayDate(date("Y-m-d H:i:s"), intval(Configuration::get('PS_LANG_DEFAULT')), true);
			Configuration::updateValue('DranerSms_LAST_ERROR', $url );
			$return = false;				
		}
		/**/
		return $response;
	}
	
	/**
	 * Call HTTP API to get number of SMS available
	 * @return int or false if an error occured
	 */
	function accountStatement($user=null, $password=null) {
		$params['login'] = $user ? $user : $this->user;
		$params['password']= $password ? $password : $this->password;
		$response = $this->_callDranerSms($this->urls['accountStatement'], $params);
		$response_params = explode('&',$response);
		
		$return = array();
		foreach ($response_params as $param) {
			$explode = explode('=',$param);
			$return[$explode[0]] = $explode[1];
		}
		
		return $return;
	}
	
	/**
	 * Private generic function to call the 123-sms http api
	 * @param $params
	 * @return string the response or false if an error occured
	 */
	private function _callDranerSms($url, $params) {
		$call = $url;
		$i = 0;
		
		foreach($params as $name => $value) {
			$symbol = ($i==0) ? '?' : '&';
			$call .= $symbol.$name.'='.urlencode($value);
			$i++;
		}
		
		// Set timeout
		ini_set('default_socket_timeout', $this->timeout);
		// tmp ----------------
		$data = $call;
		
		// Call server and retrieve response
		if(!$data=@file_get_contents($call,false,$context)){
			return false;
		}
	
		if(!preg_match('#<body>([^>]*)</body>#i',$data,$response)) {
			return false;
		}
		/**/
		return trim($response[1]);
	}
}
?>
